/********************************************************
*		Just a quick mode 4 demo  version 0.6
*
*				by devoto
*
*       Raycasting engine.  Only the walls for now and
* 	VERY unoptomised.  Texture mapping has been added at 
*       virtualy no speed hit. Added sin/cos lookup tables to 
*	give a slight speed increes. 
********************************************************/

// Gba.h has all the register definitions
#include "gba.h"//from Eloist Wire cube Demo
#include "data.h"
#include "drawmaze.h"
#include "keypad.h"

#include <math.h>




//Some direction defines 
#define UP 1
#define LEFT 2
#define DOWN 3
#define RIGHT 4
#define PI 3.14159
#define SPEED 5
#define SPEEDTURN 4
#define RADIAN(n) (((float)n)/(float)180*PI)

#define WALL_HEIGHT 64           // Height of wall in pixels
#define VIEWER_DISTANCE 128      // Viewer distance from screen
#define VIEWPORT_LEFT 0         // Dimensions of viewport
#define VIEWPORT_RIGHT 120
#define VIEWPORT_TOP 0
#define VIEWPORT_BOT 160
#define VIEWPORT_HEIGHT 160    
#define VIEWPORT_CENTER 80


typedef void (*fp)();
fp dm;

//memory offset of the palette mem and video
u16 *palette_mem = (u16*)0x5000000;
u16* Video_Buffer16 = (u16*)0x600A000;//
u32* RAM = (u32*)0x3000000;
//maze data. same old map
const char map[16*16]={
	1,1,1,1,1,1,1,3,1,1,1,2,1,1,1,1,
	1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
	1,0,1,0,2,3,1,0,1,0,1,0,1,1,0,1,
	1,0,2,0,3,0,0,0,1,1,1,0,1,1,0,1,
	1,0,3,0,0,0,1,0,0,0,1,0,0,1,0,1,
	1,0,2,3,2,0,1,0,2,0,1,3,1,1,0,1,
	1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,
	1,0,1,1,1,0,1,0,1,1,1,0,1,1,0,1,
	1,0,1,0,0,0,1,1,0,0,1,0,1,1,0,1,
	1,0,1,0,1,0,1,1,1,1,1,0,1,1,0,1,
	1,0,1,0,1,0,0,0,0,0,0,0,0,0,0,1,
	1,0,1,1,1,0,1,0,1,0,1,1,1,1,0,1,
	1,0,0,0,1,0,1,0,1,0,0,0,0,1,0,1,
	1,0,1,1,1,0,1,1,1,1,1,1,1,1,0,1,
	1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
};

//fixed point math stuff
#define fixed int
#define inttofixed(n)  ((n)<<20)
#define fixedtoint(n)  ((n)>>20)
#define floattofixed(n)  ((int)((n)*(1<<20)))
#define fixedtofloat(n)  ((float)((n)/(1<<20)))
//structure to hold a position

typedef struct xy {
	fixed x,y;
}xy;



//current position and such


struct xy pos={5*64,5*64};  //added fine coordanants.  64 units per grid position

int direction=0;   //in degrees
int height = 32;     //used to simulate walking

int mode = 0x404;  //current video mode.  Mode 4 apears to be a linear
                  //8 bit palette mode with a back buffer at 0x600A000.  You can
		  //Switch to back buffer by orring *(0x4000000) with
		  //0x10.  Cannot write bytes to video memory. 
//////////LUTs
fixed COS[360];
fixed SIN[360];
int ATAN[120];

//Declerations
void WaitForVsync(void);
int abs (int value);
void Move(int Direction);			       	//moves fwd or back
int Get_Input(void);					//reads PAD and changes Direction
void Clear_Buffer(void);				//duh
void Wait(int time);					//waits
void Flip(void);					//flips back -> front / front->back
void copyMazeToRAM(void);

///////////////// C code entry (main())/////////////////////
int C_entry()
{
	int i;//counter
	//setup the display mode
	REG_DISPCNT = mode;   //set screen mode(REG_DISPCNT = *0x4000000)
	REG_DISPSTAT = 0x02 ;  //mode 3 - 5 uses bg 2 as the background => must be enabled.

	//Palette is 256 16 bit entries:  bbbbbgggggrrrrr-
	   //sets palette 0 to red(background)
	copyMazeToRAM();
	for(i = 0; i < (256); i++)
		palette_mem[i] = palette[i];//
	for(i = 0;i<360;i++)
	{
		SIN[i] = (fixed)(sin(RADIAN(i))*((float)(1<<30)));
		COS[i] = (fixed)(cos(RADIAN(i))*((float)(1<<30)));
		if(i<120)
			ATAN[i] = atan((float)(i-60)
                         / VIEWER_DISTANCE) * 180 / PI;
;
	}
/////////////////MAIN LOOP////////////////////	
	while (1)
	 {


	Clear_Buffer();
	Move(Get_Input());	//get_input returns direction if up or down was
					//pressed, 0 otherwise.				
	
	//drawmaze(pos.x,pos.y,direction,height);//draws it
	(*dm)(pos.x,pos.y,direction,height);//draws it	

	WaitForVsync();
	Flip();               	//swap front and back buffers
	//Wait(300);		//wait a bit
	}
}
//////////////////////////////////////////////

///////WaitForVsync//////////////////////////
void WaitForVsync(void)
{
	__asm 
	{
		mov 	r0, #0x4000006   //0x4000006 is vertical trace counter when it hits 					 //160 the vblanc starts
		scanline_wait:
		ldrh	r1, [r0]
		cmp	r1, #160
		bne 	scanline_wait
	}			
}



///////////////Get Input////////////////////////////////
int Get_Input(void)
{
	int d = 0; //keep track of delta

//key bits are reset when a key is pressed.  Apperantly they must be set back to 0;

	if(!((*KEYS) & KEY_UP))        //is UP bit 0?
	{
		d = UP;			//need to Move UP
		(*KEYS) |= KEY_UP;      //reset KEY_UP bit to 1
	}
	if(!((*KEYS) & KEY_DOWN))
	{
		d = DOWN;	
		(*KEYS) |= KEY_DOWN;
	}
	if(!((*KEYS) & KEY_LEFT))
	{
		direction -= SPEEDTURN;
		if(direction < 0)
			direction = 359;

		(*KEYS) |= KEY_LEFT;
	}
	if(!((*KEYS) & KEY_RIGHT))
	{
		direction += SPEEDTURN;
		if(direction > 359)
			direction = 0;

		(*KEYS) |= KEY_RIGHT;
	}
	if(!((*KEYS) & KEY_A))
	{
		//do A button stuff here
	}
	return d;
}

/////////////////////////////////////////////////////////

////////////////////MOVE/////////////////////////////////
void Move(int d)
{
	//static int hdelta = 0;  //this is for bouncing
	struct xy old;  //holds initial xy incase we try to move into a wall
	old.x = pos.x;
	old.y = pos.y;

	if(d == UP)
	{
		pos.x += (SPEED * (COS[direction]>>4))>>26;     //move forward
		pos.y += (SPEED * (SIN[direction]>>4))>>26;		
	
	}
	if(d == DOWN)
	{
		pos.x -= (SPEED * (COS[direction]>>4))>>26;     //Move back
		pos.y -= (SPEED * (SIN[direction]>>4))>>26;		
	
	}
	if(map[(pos.x>>6) + ((pos.y>>6)<<4)])     //inside a wall move back
	{
		pos.x = old.x;
		pos.y = old.y;
	}
}

void Clear_Buffer(void)
{
	int i;
	int* Video_Buffer32 = (int*)Video_Buffer16;  //make it a 32 bit pointer 
for(i = (240*160/4); i>=0; i-=4)   
{
                 Video_Buffer32[i] = 0;//unroll it a little
			Video_Buffer32[i+1] = 0;//clouds[i+1];
			Video_Buffer32[i+2] = 0;//clouds[i+2];
			Video_Buffer32[i+3] = 0;//clouds[i+3];
}
/*
//	if(mode == 0x4)
	{
		for(i = (240*160/4/2); i>=0; i-=4)   //32 bit is faster
		{	
			Video_Buffer32[i] = clouds[i];      //unroll it a little
			Video_Buffer32[i+1] = clouds[i+1];
			Video_Buffer32[i+2] = clouds[i+2];
			Video_Buffer32[i+3] = clouds[i+3];
		}//end for
		for(i = (240*160/4); i>(240*160/4/2); i-=4)   //32 bit is faster
		{	
			Video_Buffer32[i] = 123+(123<<8)+(123<<16)+(123<<24);      //unroll it a little
			Video_Buffer32[i+1] = 123+(123<<8)+(123<<16)+(123<<24);
			Video_Buffer32[i+2] = 123+(123<<8)+(123<<16)+(123<<24);
			Video_Buffer32[i+3] = 123+(123<<8)+(123<<16)+(123<<24);
		}//end for
	}//end if*/
}// end Clear_Buffer

void Wait(int time)
{
	int i1,i2,temp;
	for(i1 = 0; i1 < time; i1++)
		for(i2 = 0; i2 < time; i2++)
			temp = i1*i2;
}//end Wait


void Flip(void)
{
	if(REG_DISPCNT == mode)
	{
		REG_DISPCNT |= 0x10;   //flip to back
		Video_Buffer16 = (u16*)0x6000000;  //draw to front
	}
	else
	{
		REG_DISPCNT = mode; //flip to front
		Video_Buffer16 = (u16*)0x600A000; //draw to back
	}//end ifelse
}//end flip
int abs (int value)
{
	if (value<0)
		return (value-(2*value));	
	else
		return value;
}

void copyMazeToRAM(void)
{
	u32* t;
	int i;

	t = (u32*)drawmaze;
	for(i = 0; i < (0x600/4);i++)
		RAM[i] = t[i];
	dm = (fp)RAM;
}